#include <stdio.h>
#include <dirent.h>
#include <malloc.h>
#include <limits.h>

typedef struct rec {
	struct rec *next;
	char name[20];
} rec;

rec *ports,*bits;

void addRec(rec **root, char *name){
	rec *prev,*act;
	int r;
	prev=0;
	act=*root;
	while(act){
		r=strcmp(act->name,name);
		if(!r) return; /* gibts schon */
		if(r>0) break;
		prev=act;
		act=act->next;
	}
	act=calloc(sizeof(rec),1);
	strcpy(act->name,name);
	if(prev){
		act->next=prev->next;
		prev->next=act;
	}
	else *root=act;
}

void procFile(char *fn){
	FILE *f;
	char st[2048],*cp;
	//printf("%s\n",fn);
	f=fopen(fn,"r");
	if(!f) return;
	while(fgets(st,2040,f)){
		if(!strncmp(st," Port ",6)){
			cp=strchr(st+6,'=');
			if(!cp) return;
			*cp=0;
			addRec(&ports,st+6);
		}
		if(!strncmp(st,"  Bit ",6)){
			cp=strchr(st+6,'=');
			if(!cp) return;
			*cp=0;
			addRec(&bits,st+6);
		}
	}
	fclose(f);
}

int main(int argc, char **argv){
	DIR *d;
	int c_po,c_bi;
	rec *act,*next;
	struct dirent *de;
	char st[PATH_MAX];
	if(argc<2){
		printf("Usage:\n");
		return -1;
	}
	d=opendir(argv[1]);
	if(!d){
		printf("Error open dir %s\n",argv[1]);
		return -1;
	}
	while(de=readdir(d)){
		if(de->d_name[0]!='!'){
			strcpy(st,argv[1]);
			strcat(st,"/");
			strcat(st,de->d_name);
			procFile(st);
		}
	}
	closedir(d);

	act=ports;
	c_po=0;
	while(act){
		printf("#define PO_%-16s %d\n",act->name,c_po++);
		next=act->next;
		act=next;
	}
	printf("#define MAX_PORTS %d\n\n",c_po);

	act=bits;
	c_bi=0;
	while(act){
		printf("#define BI_%-16s %d\n",act->name,c_bi++);
		next=act->next;
		act=next;
	}
	printf("#define MAX_BITS %d\n\n",c_bi);


	printf("\nstatic char regNames[%d ][16]={\n",c_po);
	act=ports;
	while(act){
		printf("\t\"%s\",\n",act->name);
		next=act->next;
		free(act);
		act=next;
	}
	printf("\t};\n");


	printf("\nstatic char bitNames[%d][16]={\n",c_bi);
	act=bits;
	while(act){
		printf("\t\"%s\",\n",act->name);
		next=act->next;
		free(act);
		act=next;
	}
	printf("\t};\n");

	return 0;
}
